/**
 * This function dynamically loads a shared object and returns a pointer
 * to the object handle (or NULL if there was an error).
 * The 'sofile' parameter is a system dependent name of the object file.
 */
extern void * SDL_LoadObject(const char *sofile);

/**
 * Given an object handle, this function looks up the address of the
 * named function in the shared object and returns it.  This address
 * is no longer valid after calling SDL_UnloadObject().
 */
extern void * SDL_LoadFunction(void *handle, const char *name);

/** Unload a shared object from memory */
extern void SDL_UnloadObject(void *handle);
