typedef struct WMcursor WMcursor; /* Implementation dependent */
typedef struct SDL_Cursor {
 SDL_Rect area;   /* The area of the mouse cursor */
 Sint16 hot_x, hot_y;  /* The "tip" of the cursor */
 Uint8 *data;   /* B/W cursor data */
 Uint8 *mask;   /* B/W cursor mask */
 Uint8 *save[2];   /* Place to save cursor area */
 WMcursor *wm_cursor;  /* Window-manager cursor */
} SDL_Cursor;

/* --------------- */
extern Uint8 SDL_GetMouseState(int *x, int *y);
extern Uint8 SDL_GetRelativeMouseState(int *x, int *y);
extern void SDL_WarpMouse(Uint16 x, Uint16 y);
extern SDL_Cursor * SDL_CreateCursor
  (Uint8 *data, Uint8 *mask, int w, int h, int hot_x, int hot_y);
extern void SDL_SetCursor(SDL_Cursor *cursor);
extern SDL_Cursor * SDL_GetCursor(void);
extern void SDL_FreeCursor(SDL_Cursor *cursor);
extern int SDL_ShowCursor(int toggle);

/* Used as a mask when testing buttons in buttonstate
   Button 1: Left mouse button
   Button 2: Middle mouse button
   Button 3: Right mouse button
   Button 4: Mouse wheel up  (may also be a real button)
   Button 5: Mouse wheel down (may also be a real button)
 */
#define SDL_BUTTON(X)  (1 << ((X)-1))
#define SDL_BUTTON_LEFT  1
#define SDL_BUTTON_MIDDLE 2
#define SDL_BUTTON_RIGHT 3
#define SDL_BUTTON_WHEELUP 4
#define SDL_BUTTON_WHEELDOWN 5
#define SDL_BUTTON_X1  6
#define SDL_BUTTON_X2  7
#define SDL_BUTTON_LMASK SDL_BUTTON(SDL_BUTTON_LEFT)
#define SDL_BUTTON_MMASK SDL_BUTTON(SDL_BUTTON_MIDDLE)
#define SDL_BUTTON_RMASK SDL_BUTTON(SDL_BUTTON_RIGHT)
#define SDL_BUTTON_X1MASK SDL_BUTTON(SDL_BUTTON_X1)
#define SDL_BUTTON_X2MASK SDL_BUTTON(SDL_BUTTON_X2)
